
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Audit_logsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const audit_logs = await db.audit_logs.create(
            {
                id: data.id || undefined,
        
        module: data.module
        ||
        null
            ,
            
        record_ref: data.record_ref
        ||
        null
            ,
            
        action: data.action
        ||
        null
            ,
            
        old_value: data.old_value
        ||
        null
            ,
            
        new_value: data.new_value
        ||
        null
            ,
            
        timestamp: data.timestamp
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await audit_logs.setCompany( data.company || null, {
            transaction,
        });
        
        await audit_logs.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return audit_logs;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const audit_logsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                module: item.module
            ||
            null
            ,
            
                record_ref: item.record_ref
            ||
            null
            ,
            
                action: item.action
            ||
            null
            ,
            
                old_value: item.old_value
            ||
            null
            ,
            
                new_value: item.new_value
            ||
            null
            ,
            
                timestamp: item.timestamp
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const audit_logs = await db.audit_logs.bulkCreate(audit_logsData, { transaction });

        // For each item created, replace relation files
        

        return audit_logs;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const audit_logs = await db.audit_logs.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.module !== undefined) updatePayload.module = data.module;
        
        
        if (data.record_ref !== undefined) updatePayload.record_ref = data.record_ref;
        
        
        if (data.action !== undefined) updatePayload.action = data.action;
        
        
        if (data.old_value !== undefined) updatePayload.old_value = data.old_value;
        
        
        if (data.new_value !== undefined) updatePayload.new_value = data.new_value;
        
        
        if (data.timestamp !== undefined) updatePayload.timestamp = data.timestamp;
        
        
        updatePayload.updatedById = currentUser.id;

        await audit_logs.update(updatePayload, {transaction});

        
        
        if (data.company !== undefined) {
            await audit_logs.setCompany(
              
              data.company,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await audit_logs.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return audit_logs;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const audit_logs = await db.audit_logs.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of audit_logs) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of audit_logs) {
                await record.destroy({transaction});
            }
        });


        return audit_logs;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const audit_logs = await db.audit_logs.findByPk(id, options);

        await audit_logs.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await audit_logs.destroy({
            transaction
        });

        return audit_logs;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const audit_logs = await db.audit_logs.findOne(
            { where },
            { transaction },
        );

        if (!audit_logs) {
            return audit_logs;
        }

        const output = audit_logs.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.company = await audit_logs.getCompany({
            transaction
        });
        
        
        output.user = await audit_logs.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userCompanies = (user && user.companies?.id) || null;
        

        
        if (userCompanies) {
            if (options?.currentUser?.companiesId) {
                where.companiesId = options.currentUser.companiesId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.companies,
        as: 'company',
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.module) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_logs',
                        'module',
                        filter.module,
                    ),
                };
            }
            
            if (filter.record_ref) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_logs',
                        'record_ref',
                        filter.record_ref,
                    ),
                };
            }
            
            if (filter.old_value) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_logs',
                        'old_value',
                        filter.old_value,
                    ),
                };
            }
            
            if (filter.new_value) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_logs',
                        'new_value',
                        filter.new_value,
                    ),
                };
            }
            

            
            

            
            if (filter.timestampRange) {
                const [start, end] = filter.timestampRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    timestamp: {
                    ...where.timestamp,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    timestamp: {
                    ...where.timestamp,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.action) {
                where = {
                    ...where,
                action: filter.action,
            };
            }
            


      
      if (filter.company) {
        const listItems = filter.company.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          companyId: {[Op.or]: listItems}
        };
      }
      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.companiesId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.audit_logs.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'audit_logs',
                        'module',
                        query,
                    ),
                ],
            };
        }

        const records = await db.audit_logs.findAll({
            attributes: [ 'id', 'module' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['module', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.module,
        }));
    }

    
};

